function mainfigure(X1, YMatrix1, XData1, YData1, YData2, YData3)
%CREATEFIGURE(X1, YMATRIX1, XDATA1, YDATA1, YDATA2, YDATA3)
%  X1:  vector of x data
%  YMATRIX1:  matrix of y data
%  XDATA1:  line xdata
%  YDATA1:  line ydata
%  YDATA2:  line ydata
%  YDATA3:  line ydata

%  Auto-generated by MATLAB on 18-Feb-2018 17:52:43

% Create figure
figure1 = figure('Name','Proportion Plot');

% Create axes
axes1 = axes('Parent',figure1,...
    'ColorOrder',[0 0 1;0 0.7 1;0 1 0;1 0.7 0;1 0 0]);
hold(axes1,'on');

% Create multiple lines using matrix input to plot
plot1 = plot(X1,YMatrix1,'Parent',axes1);

% Create line
hline1 = line(XData1,YData1,'Parent',axes1,'LineStyle','-');

% Create line
line(XData1,YData2,'Parent',axes1,'LineStyle','-');

% Create line
line(XData1,YData3,'Parent',axes1,'LineStyle','-');

% Create xlabel
xlabel({'$n$'},'FontSize',14,'Interpreter','latex');

% Create ylabel
ylabel({'$E[\hat{P}_{1k}]$'},'FontSize',14,'Interpreter','latex');

box(axes1,'on');

% Create legend
% legend1 = legend(axes1,'show');
legend1=legend(hline1,'$k=1$','$k=2$','$k=3$','$k=4$','$k=5$');
 set(legend1,...
     'Position',[0.739252645502642 0.592813051146387 0.163194444444444 0.217592592592593],...
     'Interpreter','latex');

% Create textbox
annotation(figure1,'textbox',[0.44 0.7 0.16 0.08],'String',{'$p = .75$'},...
    'LineStyle','none',...
    'Interpreter','latex',...
    'FontSize',12,...
    'FitBoxToText','off');

% Create textbox
annotation(figure1,'textbox',[0.44 0.43 0.16 0.08],'String',{'$p = .5$'},...
    'LineStyle','none',...
    'Interpreter','latex',...
    'FontSize',12,...
    'FitBoxToText','off');

% Create textbox
annotation(figure1,'textbox',[0.44 0.18 0.16 0.08],'String',{'$p = .25$'},...
    'LineStyle','none',...
    'Interpreter','latex',...
    'FontSize',12,...
    'FitBoxToText','off');

