function f = Ediffcprop(n,p,k)

%Version 1.0
%Date: 26-May-2015

%Description: This code calculates the expected proportion from
%appendix E.3 Equation 22 for a given n, k, p, 
%using the data files produced by running:
%1. ProccessDataDiff.m, which depends on the data produced by running
%2. ForServer.m, which calls 
%3. WriteDiffProp.m (twice), which itself calls
%4. Ediffprop.m

%nindex = @(n) find(nvalues==n);
%kindex = @(k) k-1;

%addpath('C:\Users\Miller\Dropbox\josh\work\projects\Adam\HotHand\Data\statTheory')
%rehash path
eDP=@(n) -1./(n-1);

%ePstat = @(n,p) ( n./( (n-1).*(1-(1-p).^n-p.*(1-p).^(n-1)) ) ).*( p-(1-(1-p).^n)./n );


if k>4
    error('k must be less than or equal to 5');
    return,
end

if k==1
    f=eDP(n);
else
    load DiffPropFine2.mat  %Generated in the file WriteDiffprop.m
    %p=.80;
    %k=3;
    %n=10;
    lookup=DATA{kindex(k),nindex(n)};
    n1 =lookup(:,3);
    stat=lookup(:,4);
    n=n*ones(size(n1));
    nCounted=lookup(:,5);
    nUncounted=lookup(:,6);
    
    %Average over the counted sequences, and subt
    f=sum(nCounted.*(p.^n1.*(1-p).^(n-n1)).*stat)/(1-sum(nUncounted.*(p.^n1.*(1-p).^(n-n1))));
    
    % %Equivalent to the same divided by their total probability.
    % total=sum(nCounted.*(p.^n1.*(1-p).^(n-n1)).*stat)/(sum(nCounted.*(p.^n1.*(1-p).^(n-n1))))
end

end
