cd('C:\Users\Miller\Dropbox\josh\work\projects\Adam\HotHand\Data\statTheory')
addpath('C:\Users\Miller\Dropbox\josh\work\projects\Adam\HotHand\Data\statTheory')
rehash path

%Graph for Difference in Conditional Proportions
%1. Calls Ediffcprop which
%   a. load DiffPropData.mat

clear
nvalues=[3:1:40 50:10:100];
pvalues=.25:.25:.75;
kvalues=1:3;
nindex = @(n) find(nvalues==n);
pindex = @(p) find(pvalues==p);
prop=zeros(length(nvalues),length(pvalues),length(kvalues));

for n=nvalues
    for p=pvalues
        for k=kvalues
            prop(nindex(n),pindex(p),k)=Ediffcprop(n,p,k);
        end
    end
end


    A=squeeze(prop(:,1,:)); % The p=.25 values
     B=squeeze(prop(:,2,:));  % The p=.5 values
     C=squeeze(prop(:,3,:));  % The p=.75 values
   
    k1plot=squeeze(prop(:,1,1));  %k=1 is indepent of p, so we just need 1
    B=squeeze(prop(:,2,2:3));  % for p=.5 and k=2,3
    C=squeeze(prop(:,3,2:3)); % for p=.75 and k=2,3, p=.25 is the same
    
   propplot=figure;
   axes1 = axes('Parent',propplot,...
    'Position',[0.13 0.10 0.68 0.82],...
    'ColorOrder',[0 0 1; 0 1 0;1  0 0; 0 1 0;1  0 0]);
hold(axes1,'all');
    set(propplot,'name','Proportion Plot');
    set(gca, 'ColorOrder', [0 0 1; 0 1 0;1  0 0; 0 1 0;1  0 0], 'NextPlot', 'replacechildren');
    co = get(gca,'ColorOrder') % Verify it changed
    hline1=plot(nvalues,k1plot);
%      set(hline1,'LineStyle','-',...
%          'LineWidth',1.25)
    hold all
    hline2a=plot(nvalues,B(:,1));
    hline2b=plot(nvalues,B(:,2));
    hline3=plot(nvalues,C(:,1));
    set(hline3,'LineStyle','--')
    hline4=plot(nvalues,C(:,2));
    set(hline4,'LineStyle','--')

%The Ps    


% Create textbox
annotation(propplot,'textbox',...
    [0.81 0.91 0.15 0.025],...
    'Interpreter','latex',...
    'String',{'$0<p<1$'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none');


% Create textbox
annotation(propplot,'textbox',...
    [0.81 0.865 0.0567 0.035],...
    'Interpreter','latex',...
    'String',{'$p=.5$'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none');



% Create textbox
annotation(propplot,'textbox',...
    [0.81 0.825 0.20 0.04],...
    'Interpreter','latex',...
    'String',{'$p = .25,.75$'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none');


% Create textbox
annotation(propplot,'textbox',...
    [0.81 0.79 0.06 0.03],...
    'Interpreter','latex',...
    'String',{'$p=.5$'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none');

% Create textbox
annotation(propplot,'textbox',...
    [0.81 0.73 0.20 0.042],...
    'Interpreter','latex',...
    'String',{'$p = .25,.75$'},...
    'FontSize',12,...
    'FitBoxToText','off',...
    'LineStyle','none');


%THE Ks
% Create textbox
% Create textbox
annotation(propplot,'textbox',...
    [0.19 0.73 0.049 0.035],...
    'Interpreter','latex',...
    'String',{'$k=1$'},...
    'FontSize',14,...
    'FitBoxToText','off',...
    'LineStyle','none');

annotation(propplot,'textbox',...
    [0.33 0.70 0.05 0.04],...
    'Interpreter','latex',...
    'String',{'$k=2$'},...
    'FontSize',14,...
    'FitBoxToText','off',...
    'LineStyle','none');

% Create textbox
annotation(propplot,'textbox',...
    [0.57 0.69 0.05 0.03],...
    'Interpreter','latex',...
    'String',{'$k=3$'},...
    'FontSize',14,...
    'FitBoxToText','off',...
    'LineStyle','none');

xlabel({'$n$'},'Interpreter','latex','FontSize',18);
ylabel({'$E[\hat{D}_k]$'},'Interpreter','latex','FontSize',18);  
% legend1=legend([hline2a;hline3],'$p=.5$','$p\in\{.25,.75\}$');
%     set(legend1,...
%      'Interpreter','latex',...
%      'YColor',[1 1 1],'XColor',[1 1 1],...
%     'Position',[0.73 0.50 0.10 0.16]);   
  
