log using BIAS, replace
clear
set more off
program drop _all

*This program calculates the bias for each subject in GVTs sample
*For the players with 100+
set memory 2000m  //server complains otherwise

clear
*use GVTtemp_v12.dta
use corunashooters_all.dta
by sid:egen nshots=total(make!=.)
do 3ptcode.do //because the bias computation is in there

collapse make nshots, by(sid) // generate fg% for each player
levelsof sid, local(sidlist) // create text list of sid values

forvalues i=0/1{ //calculate bias for 2+ (i==1) and 3+ (i==0)
	*forvalues j=0/1{
	local j=0 //alldata ==0
	
			matrix A=J(wordcount("`sidlist'"),4,.)
			
			*Fill the Matrix
			local it = 0
			foreach sid in `sidlist' { //iterate over each sid
				noi di "Sid # `sid'"
				noi di "Row # `it'"
			
				local ++it  // variable to control row of the matrix
				
				matrix A[`it',1] = `sid'
			
				preserve
					local nshots= nshots[`it'] //look at the .dta and get the # of shots for this row
					local fgp = make[`it']  //look at the .dta and get the fg% for this row
					
					clear
					genshots, nshots(`nshots') nsids(50000) fgpercent(`fgp') // generate 500000 data sets with nshots at fg% defined
					testbias, twoplus(`i') alldata(`j') // twoplus defines if it is 2+ or 3+ we look at, alldata if we compare to missk+ or to rest of data
					
					matrix A[`it',2]=`nshots'
					matrix A[`it',3]=`fgp'
					matrix A[`it',4]=r(mean)	// the value of "summ ehot"	within testbias, it records the bias for each fg%
					
				restore

		}
			
			*Save the matrix
			preserve
				clear
				svmat A, names(c)
				rename c1 sid
				rename c2 nshots
				rename c3 fgp
				rename c4 bias
				save biasGVT-`i'-`j'.dta  // data set recording bias
			restore		
		* }
	}



	
			matrix A=J(wordcount("`sidlist'"),4,.)
			
			*Fill the Matrix
			local it = 0
			foreach sid in `sidlist' {
				noi di "Sid # `sid'"
				local ++it
				matrix A[`it',1] = `sid'
				preserve
					local nshots= nshots[`it']
					local fgp = make[`it']
					
					clear
					genshots, nshots(`nshots') nsids(50000) fgpercent(`fgp') 
					testbias, twoplus(`i') alldata(2)
					
					matrix A[`it',2]=`nshots'
					matrix A[`it',3]=`fgp'
					matrix A[`it',4]=r(mean)			
					
				restore

			}
			
			*Save the matrix
			preserve
				clear
				svmat A, names(c)
				rename c1 sid
				rename c2 nshots
				rename c3 fgp
				rename c4 bias
				save bias-`i'-2.dta, replace
			restore		
	
	}

	set mem 50m
	log off
	log close 
	exit
