%These are the results from the Stata simulations
%Showing the bias under different models of the DGP
cd('C:\Users\Miller\Dropbox\josh\work\projects\Adam\HotHand\Data\statTheory')
addpath('C:\Users\Miller\Dropbox\josh\work\projects\Adam\HotHand\Data\statTheory')
rehash path

%Retrieve the corresponding of the array correspoding to the values we need
row = @(x,y,z) find(dgp==x& fg==y & dfg==z);

rows= @(x,z) find(dgp==x & dfg==z);
%Import excel data (after collapsing, right?)
%Something weird happened, the excel data, which was collapsed, 
%for i=0(1)3
%ediff0=ediff(find(dgp==0& fg==50 & dfg==0))

%Generate figures and save them
regimeplot=figure;
linewidth=1.5;
set(regimeplot,'name','Bias Regime Plot')
set(gca, 'ColorOrder', [0 0 1; 0 .7 1;0  1 0; 1 .7 0; 1 0 0], 'NextPlot', 'replacechildren');
co = get(gca,'ColorOrder') % Verify it changed
hline1=plot(fg(rows(0,0)),bias(rows(0,0)))
set(hline1,'LineStyle','-','Color','k','linewidth',linewidth)
hold all
hline2=plot(fg(rows(3,10)),bias(rows(3,10)))
set(hline2,'linewidth',linewidth)
hline2=plot(fg(rows(3,20)),bias(rows(3,20)))
set(hline2,'linewidth',linewidth)
hline2=plot(fg(rows(3,30)),bias(rows(3,30)))
set(hline2,'linewidth',linewidth)
hline2=plot(fg(rows(3,40)),bias(rows(3,40)))
set(hline2,'linewidth',linewidth)
ylim(gca,[-0.4 0]);
set(gca,'XTick',[40 45 50 55 60]);
hold off
savefig('regimeplot.fig')

streakplot=figure;
set(streakplot,'name','Bias Streak Plot')
set(gca, 'ColorOrder', [0 0 1; 0 .7 1;0  1 0; 1 .7 0; 1 0 0], 'NextPlot', 'replacechildren');
co = get(gca,'ColorOrder') % Verify it changed
hline1=plot(fg(rows(0,0)),bias(rows(0,0)))
set(hline1,'LineStyle','-','Color','k','linewidth',linewidth)
hold all
hline2=plot(fg(rows(1,10)),bias(rows(1,10)))
set(hline2,'linewidth',linewidth)
hline2=plot(fg(rows(1,20)),bias(rows(1,20)))
set(hline2,'linewidth',linewidth)
hline2=plot(fg(rows(1,30)),bias(rows(1,30)))
set(hline2,'linewidth',linewidth)
hline2=plot(fg(rows(1,40)),bias(rows(1,40)))
set(hline2,'linewidth',linewidth)
ylim(gca,[-0.4 0]);
set(gca,'XTick',[40 45 50 55 60]);
hold off
savefig('streakplot.fig')

hhplot=figure;
set(hhplot,'name','Bias hh Plot')
set(gca, 'ColorOrder', [0 0 1; 0 .7 1;0  1 0; 1 .7 0; 1 0 0], 'NextPlot', 'replacechildren');
co = get(gca,'ColorOrder') % Verify it changed
hline1=plot(fg(rows(0,0)),bias(rows(0,0)))
set(hline1,'LineStyle','-','Color','k','linewidth',linewidth)
hold all
hline2=plot(fg(rows(2,10)),bias(rows(2,10)))
set(hline2,'linewidth',linewidth)
hline2=plot(fg(rows(2,20)),bias(rows(2,20)))
set(hline2,'linewidth',linewidth)
hline2=plot(fg(rows(2,30)),bias(rows(2,30)))
set(hline2,'linewidth',linewidth)
hline2=plot(fg(rows(2,40)),bias(rows(2,40)))
set(hline2,'linewidth',linewidth)
ylim(gca,[-0.4 0]);
set(gca,'XTick',[40 45 50 55 60]);
hold off
savefig('hhplot.fig')



%Compbine graphs

R=hgload('regimeplot.fig');
S=hgload('streakplot.fig');
H=hgload('hhplot.fig');
figure
h(1)=subplot(1,3,1);
xlabel('FG%');
ylabel('Bias');
title('Regime Shift');
h(2)=subplot(1,3,2);
xlabel('FG%');
title('Pos. Feedback');
h(3)=subplot(1,3,3);
xlabel('FG%');
title('Pos. Feedback (hits)');
copyobj(allchild(get(R,'CurrentAxes')),h(1));
copyobj(allchild(get(S,'CurrentAxes')),h(2));
copyobj(allchild(get(H,'CurrentAxes')),h(3));

ylim(h(1),[-0.4 0]);
ylim(h(2),[-0.4 0]);
ylim(h(3),[-0.4 0]);
set(h(1),'XTick',[40 45 50 55 60]);
set(h(2),'XTick',[40 45 50 55 60]);
set(h(3),'XTick',[40 45 50 55 60]);


%set(h(1),'DisplayName','hot state')

legend1=legend(h(3),'d=0','d=.1','d=.2','d=.3','d=.4');
    set(legend1,...
    'Position',[0.73 0.20 0.15 0.10]);




%Just regime shift and positive feedback

R=hgload('regimeplot.fig');
S=hgload('streakplot.fig');
H=hgload('hhplot.fig');
figure
h(1)=subplot(1,2,1);
xlabel('FG%');
ylabel('Bias');
title('Regime Shift');
h(2)=subplot(1,2,2);
xlabel('FG%');
title('Pos. Feedback');
copyobj(allchild(get(R,'CurrentAxes')),h(1));
copyobj(allchild(get(S,'CurrentAxes')),h(2));

ylim(h(1),[-0.4 0]);
ylim(h(2),[-0.4 0]);

set(h(1),'XTick',[40 45 50 55 60]);
set(h(2),'XTick',[40 45 50 55 60]);



%set(h(1),'DisplayName','hot state')

legend1=legend(h(2),'d=0','d=10','d=20','d=30','d=40');
    set(legend1,...
    'Position',[0.73 0.20 0.15 0.10]);

%Crap below


figure
set(hhplot,'name','Bias hh Plot')
ax1 = subplot(1,3,1); % top subplot
ax2 = subplot(1,3,2); % bottom subplot
ax3 = subplot(1,3,3); % bottom subplot

set(gca, 'ColorOrder', [0 0 1; 0 .7 1;0  1 0; 1 .7 0; 1 0 0], 'NextPlot', 'replacechildren');
co = get(gca,'ColorOrder') % Verify it changed
hline1=plot(ax1,fg(rows(0,0)),bias(rows(0,0)))
set(hline1,'LineStyle','-','Color','k','linewidth',1)
hold all
hline2=plot(ax1,fg(rows(2,10)),bias(rows(2,10)))
hline2=plot(ax1,fg(rows(2,20)),bias(rows(2,20)))
hline2=plot(ax1,fg(rows(2,30)),bias(rows(2,30)))
hline2=plot(ax1,fg(rows(2,40)),bias(rows(2,40)))
